/*
	Copyright (C) 2011 Weber Yann, Schuck Clement

	This file is part of Tansive.

	Tansive is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	Tansive is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with Tansive.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef VISU_H
#define VISU_H

#include<SDL/SDL.h>
#include"map.h"
#include"creature.h"
#include"config.h"

/*
	visu.h :
		Drawing functions
*/

//Function to draw a circle
void rasterCircleRGBA(SDL_Surface* surface,int x0, int y0, int radius, Uint8 r, Uint8 g, Uint8 b, Uint8 a);
void rasterCircleRGB(SDL_Surface* surface,int x0, int y0, int radius, Uint8 r, Uint8 g, Uint8 b);

//Function to plot a pixel
void setPixel(SDL_Surface* surface, int x, int y, Uint32 pixel);
void setPixelRGB(SDL_Surface* surface, int x, int y, Uint8 r, Uint8 g, Uint8 b);
void setPixelRGBA(SDL_Surface* surface, int x, int y, Uint8 r, Uint8 g, Uint8 b, Uint8 a);
void setPixelRGBP(SDL_Surface* surface, int x, int y, Uint8 r, Uint8 g, Uint8 b, float p);

//Function to draw the map
void draw_map(SDL_Surface* screen, SDL_Surface* surface, t_map* mp);
//Function to draw a zoomed part of the map
void draw_map_zoom(SDL_Surface* screen, SDL_Surface* surface, t_map* mp, int xc, int yc, int zoom);
//Function to draw a square representing the zoom area
void draw_zoom_area(SDL_Surface* screen, SDL_Surface* surface, int xc, int yc, t_map* mp);

#endif
